---
name: Component Proposal
about: Propose a new component
---

## Description

Please describe the proposed component as thoroughly as possible - including Figma links for design, screenshots, historical context, any required functionality, optional/nice to have functionality, proposed component API design, etc. The more detail the better!

**Note:** As this is a public repo, please be careful not to include details about GitHub products or features that have not been released. In most cases, a good component proposal should be able to describe the new component without including business logic or feature details, but if you must discuss context relating to an unreleased feature, please open an issue in the private [Design Systems repo](https://github.com/github/design-systems/issues/new/choose) and link to it here.

### Design

- [ ] Design is finalized. Link to mockups/prototypes:
- [ ] Design is being finalized by feature team. Link to any in progress mockups:
- [ ] Assistance requested in finalizing design

### Component API

Optional: If you have an idea of the intended component structure, please describe here. This can include what props will be available, if there will be any nested components or subcomponents, how this component might interact with other components, any behavior Hooks that will need to be built, etc.

### Usage

Describe how the component should be used, and/or link to usage guidelines.

## Implementation

Please describe how you would like this component to be built. Design systems is happy to help with the implementation of new components (as time/roadmap allows) but also recognizes that sometimes feature teams prefer to implement components themselves.

- [ ] Feature team would like to implement this component
- [ ] Feature team would like the Design Systems team to implement this component
- [ ] This component is already built, feature team requests assistance moving it to Primer React Components from outside application
- [ ] Other: (please describe below)

## Timeline

Please describe any deadlines or context around prioritization that would be helpful for us to use when building our roadmap.

#### What to expect next

A Design Systems engineer will read through your component proposal and get in touch! We'll gather any additional information needed and set up a Zoom call only if necessary. Once we have all relevant information, we'll add the component to our [Primer React Components Roadmap](https://github.com/primer/react/projects/3). If you opt to build the component yourself, we are happy to help with pairing, brainstorming, etc. Generally, component work requested from internal feature teams receives higher priority over general (non-requested) improvements to the library.
